class Tag{

	protected int ftype=0;
	protected String fname="";
	protected String fattrib="";
	protected String frecord="";
	protected int ftagid;
	protected int[] fchild;
	protected int ffather;
	protected int fchildid;
	protected int findex;
	protected int fnexttag;

	public Tag(){
	}

	public void arrayDisplayTag(TypeArray[] index){
		if(this.ftype==1){
			if((this.fattrib)!=""){
				System.out.print("<"+this.fname);
				if((this.frecord)!=""){
					System.out.println(" "+this.fattrib+">");
					System.out.println(this.recordOfTypeArray(index));
				}
				else{
					System.out.print(" "+this.fattrib+">");
				}
			}
			else{
				if((this.frecord)!=""){
					System.out.println("<"+this.fname+">");
					System.out.println(this.recordOfTypeArray(index));
				}
				else{
					System.out.print("<"+this.fname+">");
				}
			}
		}
		if(this.ftype==2){
			System.out.print("<"+this.fname);
			if((this.fattrib)!="")
				System.out.println(" "+this.recordOfTypeArray(index)+"/>");
			else{
				System.out.println(" />");
			}
		}
		if(this.ftype==3)
			System.out.println("</"+this.fname+">");
	}

	public String tagName(){
		return this.fname;
	}

	public String tagRecord(){
			return this.frecord;
	}

	public String tagAttrib(){
				return this.fattrib;
	}

	public void addTag(Tag[] tagar){
		for(int i=0;i<tagar.length;i++){
			if(tagar[i]==null){
				tagar[i]=this;
				this.ftagid=i;
				break;
			}
		}
	}

	public void copyRecord(Tag tag){
		tag.frecord=this.frecord;
		this.frecord="";
	}

 	public void indexOfRecord(int i){
 		this.findex=i;
  	}

	public String recordOfTypeArray(TypeArray[] index){
		return (this.findTypeArray(index)).recordOut(this.findex);
	}

	public TypeArray findTypeArray(TypeArray[] index){
		int n=0;
		for(int i=0;i<index.length;i++){
			if((index[i].TypeArrayName()).equals(this.tagName())){
				n=i;
			}
		}
		return index[n];
	}

	public void linkTag(Tag tag){
		if(tag!=null)
			this.fnexttag=tag.ftagid;
	}

	public void displayArrayDoc(Tag[] tagar,TypeArray[] index){
		this.arrayDisplayTag(index);
		Tag n=new Tag();
		while(this.fnexttag!=0){
			n=tagar[this.fnexttag];
			n.displayArrayDoc(tagar,index);
		}
		System.exit(0);
	}

	public void treeDisplayTag(){
			if(this.ftype==1){
				if((this.fattrib)!=""){
					System.out.print("<"+this.fname);
					if((this.frecord)!=""){
						System.out.println(" "+this.fattrib+">");
						System.out.println(this.frecord);
					}
					else{
						System.out.print(" "+this.fattrib+">");
					}
				}
				else{
					if((this.frecord)!=""){
						System.out.println("<"+this.fname+">");
						System.out.println(this.frecord);
					}
					else{
						System.out.print("<"+this.fname+">");
					}
				}
			}
			if(this.ftype==2){
				System.out.print("<"+this.fname);
				if((this.fattrib)!="")
					System.out.println(" "+this.fattrib+"/>");
				else{
					System.out.println(" />");
				}
			}
			if(this.ftype==3)
				System.out.println("</"+this.fname+">");
	}

	public void childOf(Tag tag){
		if (tag==null)
			System.out.println("");
		else{
			for(int i=0;i<tag.fchild.length;i++){
				if(tag.fchild[i]==0){
					tag.fchild[i]=this.ftagid;
					break;
				}
			}
		}

	}

	public void fatherOf(Tag tag){
		if(tag==null)
			this.ffather=-1;
		else{
			this.ffather=tag.ftagid;
		}
	}

	private int childId(){
			return this.fchildid;
	}

	private void childId(Tag[] tagar,Tag tag){
		if(tag==null)
			this.fchildid=-1;
		else{
			for(int i=0;i<(tag.fchild).length;i++){
				if ((tag.findTagChild(tagar,i))==this){
					this.fchildid=i;
					break;
				}
			}
		}
	}

	private Tag findTagChild(Tag[] tagar, int i){
		if(this.fchild[i]!=0){
			int id=this.fchild[i];
			return tagar[id];
		}
		else{
			return null;
		}
	}

	private Tag findTagFather(Tag[] tagar){
		int id=this.ffather;
		if(id==-1)
			return null;
		else{
			return tagar[id];
		}
	}

	private Tag findTagFirstChild(Tag[] tagar){
		if(this.fchild!=null){
			int id=this.fchild[0];
			return tagar[id];
		}
		else{
			return null;
		}
	}

	private Tag findTagBrother(Tag[] tagar){
	 	Tag tag=new Tag();
		tag =this.findTagFather(tagar);
		this.childId(tagar,tag);
		int i=this.childId();
		int j=i+1;
		if((tag.findTagChild(tagar,j))!=null)
			return tag.findTagChild(tagar,j);
		else{
			return tag.findTagBrother(tagar);
		}
	}

	public void displayTreeDoc(Tag[] tagar){
		Tag c=new Tag();
		c=this;
		c.treeDisplayTag();
		Tag d=new Tag();
		d=c.findTagFirstChild(tagar);
		if(d!=null){
			d.displayTreeDoc(tagar);
		}
		else{
			c=c.findTagBrother(tagar);
			c.displayTreeDoc(tagar);
		}

	}

}